require 'sketchup.rb'

module MSketchyPhysics3

  class << self

    def testPlay
      MSketchyPhysics3::SketchyPhysicsClient.physicsTogglePlay
      if MSketchyPhysics3::SketchyPhysicsClient.active?
        MSketchyPhysics3.showControlPanel unless @test_play
      end
      @test_play = true
    end

    def testChecked
      if MSketchyPhysics3::SketchyPhysicsClient.active?
        if @test_play
          MF_CHECKED
        elsif @game_play
          MF_GRAYED
        end
      else
        @test_play = nil
      end
    end

    def gamePlay
      MSketchyPhysics3::SketchyPhysicsClient.startphysics
      if MSketchyPhysics3::SketchyPhysicsClient.active?
        unless @game_play
          MSketchyPhysics3.hiddenDialog
          Sketchup.send_action("viewShowAxes:")
          MSketchyPhysics3.closeSound
          $spObjectInspector.cleanup
          MSketchyPhysics3.setCapture if RUBY_PLATFORM =~ /mswin|mingw/i
        end
      end
      @game_play = true
    end

    def gameChecked
      if MSketchyPhysics3::SketchyPhysicsClient.active?
        if @game_play
          if RUBY_PLATFORM =~ /mswin|mingw/i
            if getKeyState(VK_ESCAPE)
              SketchyPhysicsClient.physicsReset
              MSketchyPhysics3.getRCapture
              Sketchup.send_action("viewShowAxes:")
            end
          else
            if getKeyState(VK_ESC)
              SketchyPhysicsClient.physicsReset
              Sketchup.send_action("viewShowAxes:")
            end
          end
          MF_CHECKED
        elsif @test_play
          MF_GRAYED
        end
      else
        @game_play = nil
      end
    end
    
    def gamePlay?
      @game_play ? true : false
    end

    def resetSim
      unless MSketchyPhysics3::SketchyPhysicsClient.active?
        MF_GRAYED
      else
        MF_GRAYED if @game_play
      end
    end
  end
end